
(* :Title: CompositionOfFunctions$exs *)

(* :Author: N. A. Nicorovici, School of Mathematical Sciences, 
            University of Technology, Sydney, NSW 2007, Australia. 
*)

(* :Summary:
Exercises with functions.
*)

(* :Context: SetTheory`CompositionOfFunctions$exs` *)

(* :Package Version: 1.0 *)

(* :Copyright: *)

(* :History:
Version 1.0 by N. A. Nicorovici, 1999.
16 June 2002 --- modified for webMathematica. 
*)

(* :Keywords:
	Relations, Functions, Composition of Functions
*)

(* :Source: None. *)

(* :Warning: *)

(* :Mathematica Version: 3.0 *)

(* :Requirements: None *)

(* :Limitations: None known. *)

(* :Discussion: *)

BeginPackage["SetTheory`CompositionOfFunctions$exs`"]

MSP$cof$sc

MSP$cof$cp

SyntaxError

CoF$msg

Unprotect[MSP$cof$sc, MSP$cof$cp]

Begin["`Private`"]

impp$protected= Unprotect[select$tdc,select$ex,testanswer,wronganswer,
                          convert$output,convert$input,cp$1,
                          syntax$check,cf$aux1,cf$aux2]
evaluation$check = False

cf$aux1[pair_, gpairs_]:={pair[[1]],
                          Last[Select[gpairs, (#[[1]]===pair[[2]])&][[1]]]}

cf$aux2[fpairs_, gpairs_]:=Map[cf$aux1[#,gpairs]&, fpairs]


select$tdc[x___]:=Module[{left$symbols,mid$symbols,right$symbols,
                          types$1,mask$1,nl,nm,nr,nt,nn},

left$symbols  = {"a","b","c","d","e","f","g"};
mid$symbols   = {"1","2","3","4","5","6","7"};
right$symbols = {"t","u","v","w","x","y","z"};

nl = Random[Integer, {1,7}];
nm = Random[Integer, {1,7}];
nr = Random[Integer, {1,7}];
If[ nm>nl, nm=nl ];

f$domain   = Take[left$symbols,  nl];

f2g$domain = Take[mid$symbols,   nm];
m$domain   = f2g$domain;
If[ nm<nl, pos=Table[Random[Integer, {1,nm}], {nl-nm}];
           tmp$domain=f2g$domain[[pos]];
           m$domain=Join[f2g$domain, tmp$domain]];

g0$codomain = Take[right$symbols, nr];
g$codomain  = g0$codomain;
If[ nr<nm, pos=Table[Random[Integer, {1,nr}], {nm-nr}];
           tmp$domain=g$codomain[[pos]];
           g$codomain=Join[g$codomain, tmp$domain]];


x$codomain = Permutations[m$domain];
z$codomain = x$codomain[[Random[Integer, {1,Length[x$codomain]}]]];
f$pairs    = Transpose[{f$domain, z$codomain}];

x$codomain = Permutations[g$codomain];
y$codomain = Take[x$codomain[[Random[Integer, {1,Length[x$codomain]}]]],
                                                                      nm];
g$pairs    = Transpose[{f2g$domain, y$codomain}];

res        = cf$aux2[f$pairs, g$pairs];

x$codomain = .;
y$codomain = .;
z$codomain = .;

{f$domain, f2g$domain, g0$codomain, f$pairs, g$pairs}
]


convert$output[x_String] := "{"<>StringReplace[
                                 StringDrop[StringDrop[x, 1], -1], 
                                             {"{"->"(","}"->")"}]<>"}"

convert$input[x_String] := StringReplace[x, {"("->"{",")"->"}"}]



select$ex[x___]:=Module[{A$A,B$B,C$C,fpairs,gpairs},

cnt$ans=0;

{A$A, B$B, C$C, fpairs, gpairs} = select$tdc[ ];

f$text = "Let f:A->B and g:B->C be two functions having "<>
         "the domains and codomains\n"<>
         "\t\tA = "<>ToString[A$A]<>", \n"<>
         "\t\tB = "<>ToString[B$B]<>", \n"<>
         "\t\tC = "<>ToString[C$C]<>", \n"<>
         "defined by the ordered pairs\n"<>
         "\t\tf = "<>convert$output[ToString[fpairs]]<>", \n"<>
         "\t\tg = "<>convert$output[ToString[gpairs]]<>". ";

SetTheory`CompositionOfFunctions$exs`Private`f$text
]


(* CHECK ANSWER *)

wronganswer[answer__, res__] := Module[{},
     test = Intersection[ToString/@answer, ToString/@res];
     test$out   = convert$output[ToString[test]];
     answer$out = convert$output[ToString[answer]];
     If[ Length[test]==0,
       text = "Your answer: \n"<>
               SetTheory`CompositionOfFunctions$exs`Private`answer$out<>"\n"<>
              "is incorrect.", 
       text = "Your answer: \n"<>
             SetTheory`CompositionOfFunctions$exs`Private`answer$out<>"\n"<>
             "is partially correct. The correct part is: \n"<>
             SetTheory`CompositionOfFunctions$exs`Private`test$out
       ];
text
]


syntax$check[s_] := Module[{s0, s1, nleftb, nrightb, elements, sx},

string$check = False ;
s0    = StringReplace[ToString[s], {"{"->"", " "->"", "}"->""}];

If[StringLength[s0] > 0,
   s1 = Characters[s0];

   nleftb  = Length[Select[s1,(#=="(")&]];
   nrightb = Length[Select[s1,(#==")")&]];

   If[ nleftb != nrightb,
      Throw[False, SyntaxError["Unbalanced Parenthesis"]]
     ];

   X$sets   = {f$domain, g0$codomain};
   elements = Union[Map[ToString[#]&, Flatten[X$sets]], {"(",")",","," "}];
   sx       = Complement[s1, elements];
   sx$out   = ToString[sx];

   If[ Length[sx] != 0,
      Throw[False, SyntaxError["Wrong Symbol(s) or Separator(s): \n"<>
             SetTheory`CompositionOfFunctions$exs`Private`sx$out]]
     ],

   Throw[False, SyntaxError["No Input"]]
];

string$check = True;
{True, Null}
]


MSP$cof$sc[s_String] := Module[{tmp,res},
  tmp = Catch[ syntax$check[s], _SyntaxError, List];
  res = tmp
]



cp$1[R_] := Module[{sel$sets, cp$sets, wrans, addcell},
     If[ cnt$ans>2,
         Throw[False, CoF$msg["Close this window and select another exercise."]]];

     answer   = ToExpression[convert$input[R]];
     answer$1 = convert$output[ToString[answer]];
     res$1    = convert$output[ToString[res]];

     If[
     (Length[Intersection[ToString/@answer,ToString/@res]]==Length[res])&&
     (Length[answer]==Length[res]),
(* Right answer *)
   cnt$ans=3; 
   Throw[cnt$ans, CoF$msg["Your answer: \n"<>
                SetTheory`CompositionOfFunctions$exs`Private`answer$1<>"\n"<>
                "is correct."]],
(* Wrong answer *)
     wrans = wronganswer[answer, res];
     If[ cnt$ans==2,
     addcell = "You failed three times. The correct answer is: \n"<> 
                SetTheory`CompositionOfFunctions$exs`Private`res$1;
             cnt$ans++,
     addcell = "Try again."; 
             cnt$ans++]
       ];
     Throw[cnt$ans-1, CoF$msg[ wrans<>"\n\n"<>addcell ]];
]


MSP$cof$cp[s_String] := Module[{tmp,res},
  tmp = Catch[ cp$1[s], _CoF$msg, List];
  res = tmp
]



(* EPILOG *)

SetAttributes[select$tdc,     ReadProtected]
SetAttributes[select$ex,      ReadProtected]
SetAttributes[testanswer,     ReadProtected]
SetAttributes[wronganswer,    ReadProtected]
SetAttributes[convert$output, ReadProtected]
SetAttributes[convert$input,  ReadProtected]
SetAttributes[cp$1,           ReadProtected]
SetAttributes[syntax$check,   ReadProtected]
SetAttributes[cf$aux1,        ReadProtected]
SetAttributes[cf$aux2,        ReadProtected]

Protect[Evaluate[impp$protected]]

End[]  (*CompositionOfFunctions$exs`Private`*)

SetAttributes[ MSP$cof$sc, ReadProtected]
SetAttributes[ MSP$cof$cp, ReadProtected]

Protect[MSP$cof$sc, MSP$cof$cp]

EndPackage[] (* Mappings$exs`*)


