
(* :Title: InverseMappings$exs *)

(* :Author: N. A. Nicorovici, School of Mathematical Sciences, 
            University of Technology, Sydney, NSW 2007, Australia. 
*)

(* :Summary:
Exercises with functions.
*)

(* :Context: SetTheory`InverseMappings$exs` *)

(* :Package Version: 1.0 *)

(* :Copyright: *)

(* :History:
Version 1.0 by N. A. Nicorovici, 1999. 
MSP version, 2002.
*)

(* :Keywords:
	Relations, Functions, Inverse Functions
*)

(* :Source: None. *)

(* :Warning: *)

(* :Mathematica Version: 3.0 *)

(* :Requirements: None *)

(* :Limitations: None known. *)

(* :Discussion: *)

BeginPackage["SetTheory`InverseMappings$exs`"]

InverseMappings$Error

InverseMappings$msg

MSP$cp$1

Unprotect[InverseMappings$Error,InverseMappings$msg,MSP$cp$1]

Begin["`Private`"]

impp$protected= Unprotect[select$tdc,select$ex,testanswer,wronganswer,
                          convert$output,convert$input,cp$1,
                          syntax$check]

evaluation$check = False;

select$tdc[x___]:=Module[{left$symbols,right$symbols,types$1,mask$1,
                          nl,nr,nt,nn},

left$symbols  = {"a","b","c","d","e","f","g"};
right$symbols = {"t","u","v","w","x","y","z"};

nl = Random[Integer, {1,7}];
nr = Random[Integer, {1,7}];
If[ nl != nr, nn=Max[nl,nr]; nl=nn; nr=nn ];

f$domain   = Take[left$symbols,  nl];
f$codomain = Take[right$symbols, nr];
x$codomain = Permutations[f$codomain];
z$codomain = x$codomain[[Random[Integer, {1,Length[x$codomain]}]]];
x$codomain = .;
f$pairs    = Transpose[{f$domain, z$codomain}];
res        = Transpose[{z$codomain, f$domain}];

{f$domain, f$codomain, f$pairs}
]


select$ex[x___]:=Module[{domain,codomain,pairs},

cnt$ans=0;

{domain, codomain, pairs} = select$tdc[ ];

f$text = "Let f:A->B be a 1-1 and onto function having the domain\n"<>
         "\t\tA = "<>ToString[domain]<>", \n"<>
         "and the codomain\n"<>
         "\t\tB = "<>ToString[codomain]<>", \n"<>
         "defined by the ordered pairs\n"<>
         "\t\tf = "<>ToString[pairs]<>". ";

SetTheory`InverseMappings$exs`Private`f$text
]


(* CHECK ANSWER *)

testanswer[answer__, res__] := answer === res

wronganswer[answer__, res__] := Module[{},
     test = Intersection[answer, res];
     test$out   = ToString[test];
     answer$out = ToString[answer];
     If[ Length[test]==0,
         text = "Your answer: \n"<>
             SetTheory`InverseMappings$exs`Private`answer$out<>"\n "<>
                "is incorrect.", 
         text = "Your answer: \n"<>
             SetTheory`InverseMappings$exs`Private`answer$out<>"\n "<>
                "is partially correct. "<>
             "The correct part is: \n"<>
             SetTheory`InverseMappings$exs`Private`test$out
       ];
text
]


convert$output[x_String] := "{"<>StringReplace[
                                 StringDrop[StringDrop[x, 1], -1], 
                                             {"{"->"(","}"->")"}]<>"}"

convert$input[x_String] := StringReplace[x, {"("->"{",")"->"}"}]


syntax$check[s_String] := Module[{s0, s1, nleftb, nrightb, elements, sx},

  string$check = False ;
  s0 = StringReplace[convert$output[s], {"{"->"", " "->"", "}"->""}];
  s1 = Characters[s0];

  nleftb  = Length[Select[s1,(#=="(")&]];
  nrightb = Length[Select[s1,(#==")")&]];

  If[ nleftb != nrightb,
     Throw[False, InverseMappings$Error["Unbalanced Parenthesis"]]];

  X$sets   = {f$domain, f$codomain};
  elements = Union[Map[ToString[#]&, Flatten[X$sets]], {"(",")",","," "}];
  sx       = Complement[s1, elements];
  sx$out   = ToString[sx];

  If[ Length[sx] != 0,
     Throw[False, InverseMappings$Error["Wrong Symbol(s) or Separator(s): \n"<>
             SetTheory`InverseMappings$exs`Private`sx$out]]];

string$check = True;
{True, s}
]


removeall = { "\\012"->"", " "->"", "("->"", ")"->"", "{"->"", "}"->"", ","->"" } ;


cp$1[R_] := Module[{sel$sets, cp$sets, wrans, addcell},
     If[ cnt$ans>2,
         Throw[cnt$ans, InverseMappings$msg[ "Close this window and try another exercise."]]];

     answer   = Partition[Characters[StringReplace[R,removeall]],2];
     answer$1 = R;
     res$1    = ToString[res];

     If[ testanswer[answer, res],
(* Right answer *)
   cnt$ans=3; 
   Throw[cnt$ans, InverseMappings$msg[ "Your answer: \n"<>
                SetTheory`InverseMappings$exs`Private`answer$1<>"\n "<>
                "is correct."]], 
(* Wrong answer *)
     wrans = wronganswer[answer, res];
     If[ cnt$ans==2,
     addcell = "You failed three times.\n"<>
                "The correct answer is: \n"<> 
                ToString[SetTheory`InverseMappings$exs`Private`res$1];
     cnt$ans++,
     addcell = "Try again"; 
     cnt$ans++
     ]
   ];
 Throw[cnt$ans-1, InverseMappings$msg[ wrans<>"\n\n"<>addcell]];
 Return[False];
]


MSP$cp$1[R_] := Module[{tmp,res},
  tmp = Catch[ cp$1[R], _InverseMappings$msg, List];
  res = tmp
]


(* EPILOG *)

SetAttributes[select$tdc,     ReadProtected]
SetAttributes[select$ex,      ReadProtected]
SetAttributes[testanswer,     ReadProtected]
SetAttributes[wronganswer,    ReadProtected]
SetAttributes[convert$output, ReadProtected]
SetAttributes[convert$input,  ReadProtected]
SetAttributes[cp$1,           ReadProtected]
SetAttributes[syntax$check,   ReadProtected]

Protect[Evaluate[impp$protected]]

End[]  (*InverseMappings$exs`Private`*)

SetAttributes[ InverseMappings$Error, ReadProtected]
SetAttributes[ InverseMappings$msg,   ReadProtected]
SetAttributes[ MSP$cp$1,              ReadProtected]

Protect[InverseMappings$Error,InverseMappings$msg,MSP$cp$1]

EndPackage[] (* InverseMappings$exs`*)


