
(* :Title: Logic$exs$01 *)

(* :Author: N. A. Nicorovici, School of Mathematical Sciences, 
            University of Technology, Sydney, NSW 2007, Australia. 
*)

(* :Summary:
This package solves exercises from the notebook "logic1.nb".
*)

(* :Context: SetTheory`Logic$exs$01` *)

(* :Package Version: 1.0 *)

(* :Copyright: *)

(* :History:
Version 1.0 by N. A. Nicorovici, 1999. 
Changed for MSP on 7 July 2002.
*)

(* :Keywords:
	SetTheory, Logic, TruthTable, Tautology, Contingency
*)

(* :Source: None. *)

(* :Warning: *)

(* :Mathematica Version: 3.0 *)

(* :Requirements: None *)

(* :Limitations: None known. *)

(* :Discussion: *)

BeginPackage["SetTheory`Logic$exs$01`", {"SetTheory`Logic`"}]

logic$1

Logic$msg

Unprotect[logic$1]

Begin["`Private`"]

logic$protected = Unprotect[clr, MyTruthTable, generate$table,
                            select$table]

cellbkg = RGBColor[1.,0.380001,0.009995] (* CadmiumOrange *) 
evaluation$check = False

logic$vars  = {"p","q","r","s","t","u","v","w"}

logic$funcs$list  = {
   {"~p"},
   {"q\[And]r", "p\[And](q\[And]r)"},
   {"p\[And]q", "p\[And](~q\[And]r)"},
   {"p\[And]q", "p\[And]~(q\[And]r)"},
   {"p\[And]q"},
   {"p\[Or]q"},
   {"p\[Or]q", "p\[And]q", "~(p\[And]q)", "(p\[Or]q)\[And]~(p\[And]q)"}
                    }

nvars$nfuncs$list = {{1,1},{3,2},{3,2},{3,2},{2,1},{2,1},{2,4}}


(* Auxiliary Functions *)

clr[{f___}] := Clear[f]

MyTruthTable[n_Integer?Positive,{funcs___}] := Module[{},
                                            TruthTable[n,funcs]]

select$table[nt_, x___] := Module[{n},
(* n = Random[Integer, {1,Length[x]}]; *)
n = nt;
logic$funcs = logic$funcs$list[[n]];
nv$nf$out   = nvars$nfuncs$list[[n]];
generate$table[nv$nf$out]
]


generate$table[{n$vars_, n$funcs_}] := Module[
  {p$funcs,f$funcs,cvt$funcs,f$1,f$n,f$2,out$table,table$list,table$1,
   logic$frules,change$header,new$table$list,new$table,
   t$1,t$2,t$3,fs$args},

cnt$ans = 0;

lg$vars = Take[logic$vars, n$vars];
p$funcs = Map[
          StringReplace[#,{"\[Not]"->"~","\[And]"->"*","\[Or]"->"v"}]&,
              logic$funcs];
f$funcs = Map[PrincipiaToFunctional[#]&, p$funcs];

cvt$funcs = Map[
  StringReplace[ToString[#],{"p"->"#1","q"->"#2","r"->"#3","s"->"#4"}]&,
                f$funcs];

f$1 = Map[PrincipiaToFunctional[#]&, p$funcs];
f$n = Table[FromCharacterCode[i+96], {i,n$funcs}];
clr[f$n];

f$args = {"[p_],", "[p_,q_],", "[p_,q_,r_],", "[p_,q_,r_,s_],"};

f$2 = ToExpression[MapThread[
           ("SetDelayed["<>FromCharacterCode[#1+96]<>f$args[[n$vars]]<>
             ToString[#2]<>"]")&,
                                      {Range[1,n$funcs], f$1}]];

out$table = TableForm[MyTruthTable[n$vars, ToExpression[f$n]]];
table$list= MyTruthTable[n$vars, ToExpression[f$n]];
table$1   = Transpose[Drop[table$list, 1]];
table$res = Take[table$1, -n$funcs];

table$string = Map[ToString[#]&, Flatten[table$list]];
logic$frules = MapThread[
               ("\""<>FromCharacterCode[#1+96]<>"\"->\""<>#2<>"\"")&,
                         {Range[1,n$funcs], logic$funcs}];
change$header= Map[
                   StringReplace[#,ToExpression[logic$frules]]&,
                   table$string];
new$table$list = Partition[change$header, n$vars+n$funcs];
new$table      = TableForm[new$table$list, TableAlignments->Center];

t$1 = Take[Transpose[new$table$list], n$vars];
t$2 = Partition[Map[
          StringReplace[#,{"T"->"\[Placeholder]","F"->"\[Placeholder]"}]&,
          Flatten[Take[Transpose[new$table$list],-n$funcs]]],2^n$vars+1];
t$3 = Transpose[Join[t$1, t$2]];
SetOptions[TableForm, TableAlignments->Center];
output$table = t$3
]


(* Main Function for Logic*)

logic$1[{n$vars_, n$funcs_}, answer$0_] := Module[
                                {wrans, addcell, text},
     If[ cnt$ans>2,
         Throw[255, Logic$msg["Close this window and try another exercise."]]
       ];

     res      = table$res;
     res$1    = Partition[ToString /@ Flatten[res], 2^n$vars];
     answer   = ToExpression[answer$0];
     answer$1 = Partition[ToString /@ Flatten[answer], 2^n$vars];

     If[ Apply[Plus, MapThread[If[#1==#2, 0, 1]&, 
                     {Flatten[answer$1], Flatten[res$1]}]] == 0,
(* Right answer *)
   cnt$ans=3; 
   Throw[cnt$ans, Logic$msg["Your answer is correct."]], 
(* Wrong answer *)
     If[ cnt$ans==2,
         cnt$ans++;
     Throw[cnt$ans-1, Logic$msg["You failed three times. The correct answer is:"]],
         cnt$ans++;
     Throw[cnt$ans-1, Logic$msg["Your answer is incorrect."]]
       ]
       ];
]


(* EPILOG *)

SetAttributes[ clr,            ReadProtected]
SetAttributes[ MyTruthTable,   ReadProtected]
SetAttributes[ generate$table, ReadProtected]
SetAttributes[ select$table,   ReadProtected]

Protect[Evaluate[logic$protected]]

End[]  (*Logic$exs$01`Private`*)

SetAttributes[ logic$1,        ReadProtected]

Protect[logic$1, logic$exs]

EndPackage[] (* Logic$exs$01`*)


