
(* :Title: Logic$exs$02 *)

(* :Author: N. A. Nicorovici, School of Mathematical Sciences, 
            University of Technology, Sydney, NSW 2007, Australia. 
*)

(* :Summary:
This package solves exercises from the notebook "logic1.nb".
*)

(* :Context: SetTheory`Logic$exs$02` *)

(* :Package Version: 1.0 *)

(* :Copyright: *)

(* :History:
Version 1.0 by N. A. Nicorovici, 1999. 
Changed for MSP on 7 July 2002.
*)

(* :Keywords:
	SetTheory, Logic, TruthTable, Tautology, Contingency
*)

(* :Source: None. *)

(* :Warning: *)

(* :Mathematica Version: 3.0 *)

(* :Requirements: None *)

(* :Limitations: None known. *)

(* :Discussion: *)

BeginPackage["SetTheory`Logic$exs$02`", {"SetTheory`Logic`"}]

logic$2

Unprotect[logic$2]

Begin["`Private`"]

logic$protected$2 = Unprotect[clr,select$f$pairs,generate$onetable,
                              My$Truth$Table,
                              lgex$rightanswer,lgex$wronganswer]

cellbkg = RGBColor[1.,0.380001,0.009995] (* CadmiumOrange *) 
evaluation$check = False

logic$vars  = {"p","q","r","s","t","u","v","w"}

y$funcs$list  = {"p\[Or](p\[And]q)", "p",             "p",
                 "p\[Or](p\[And]q)", "p\[Or](p\[And]q)"}

z$funcs$list  = {"p",                "p\[Or]\[Not]p", "p\[And]\[Not]p",
                 "p\[And]\[Not]p",   "p\[Or](p\[And]q)"}

n$y$vars$list = {2, 1, 1, 2, 2}

n$z$vars$list = {1, 1, 1, 1, 2}

test$f$args = {"[p_]", "[p_,q_]", "[p_,q_,r_]", "[p_,q_,r_,s_]"}


(* Auxiliary Functions *)

clr[{f___}] := Clear[f]


My$Truth$Table[n_Integer?Positive,{funcs___}] := Module[{},
                                            TruthTable[n,funcs]]


select$f$pairs[x___] := Block[{n, n$y$, n$z$, n$yz, y$f, z$f},

n         = Random[Integer, {1,Length[x]}];
y$string$ = StringReplace[y$funcs$list[[n]],
                            {"\[Not]"->"~","\[And]"->"*","\[Or]"->"v"}];
z$string$ = StringReplace[z$funcs$list[[n]],
                            {"\[Not]"->"~","\[And]"->"*","\[Or]"->"v"}];

n$y$ = n$y$vars$list[[n]];
n$z$ = n$z$vars$list[[n]];
n$yz = Max[n$y$, n$z$];

y$f  = ToString[PrincipiaToFunctional[y$string$]];
z$f  = ToString[PrincipiaToFunctional[z$string$]];

clr[{SetTheory`Logic$exs$02`Private`a}];
x$test = ToExpression["SetDelayed["<>"a"<>test$f$args[[n$yz]]<>","<>
                                     "E["<>y$f<>","<>z$f<>"]]"];
 
result    = TautologyQ[n$yz, SetTheory`Logic$exs$02`Private`a];
table$1$2 = generate$onetable[n$y$, 2, y$funcs$list[[n]], z$funcs$list[[n]]];
last$columns = Drop[#,1]&/@(Take[Transpose[table$1$2],-2]);
If[ Apply[Plus, MapThread[If[#1==#2, 0, 1]&, 
                     last$columns]] == 0, result = True, False];
(*
NotebookWrite[EvaluationNotebook[], Cell[result, "Text"]];
NotebookWrite[EvaluationNotebook[], Cell[table$1$2, "Text"]];
*)

lg$exp$1   = StringReplace[y$funcs$list[[n]], {"\[Not]"->"~"}];
lg$exp$2   = StringReplace[z$funcs$list[[n]], {"\[Not]"->"~"}];
out$string = {"Decide if the logical equivalence  \n",
             ToString[SetTheory`Logic$exs$02`Private`lg$exp$1]<>
             " \[Congruent] "<>
             ToString[SetTheory`Logic$exs$02`Private`lg$exp$2],
             "\n\nis  TRUE  or  FALSE. Use the buttons below for your answer."}
]


generate$onetable[n$vars_, n$funcs_, lg$funcs__] := Module[
  {p$funcs,f$funcs,cvt$funcs,f$1,f$n,f$2,out$table,table$list,table$1,
   logic$frules,change$header,new$table$list,new$table,logic$funcs,
   t$1,t$2,t$3,fs$args},

logic$funcs = {lg$funcs};

lg$vars = Take[logic$vars, n$vars];
p$funcs = Map[
          StringReplace[#,{"\[Not]"->"~","\[And]"->"*","\[Or]"->"v"}]&,
              logic$funcs];
f$funcs = Map[PrincipiaToFunctional[#]&, p$funcs];

cvt$funcs = Map[
  StringReplace[ToString[#],{"p"->"#1","q"->"#2","r"->"#3","s"->"#4"}]&,
                f$funcs];

f$1 = Map[PrincipiaToFunctional[#]&, p$funcs];
f$n = Table[FromCharacterCode[i+96], {i,n$funcs}];
clr[f$n];

f$args = {"[p_],", "[p_,q_],", "[p_,q_,r_],", "[p_,q_,r_,s_],"};

f$2 = ToExpression[MapThread[
           ("SetDelayed["<>FromCharacterCode[#1+96]<>f$args[[n$vars]]<>
             ToString[#2]<>"]")&,
                                      {Range[1,n$funcs], f$1}]];

out$table = TableForm[My$Truth$Table[n$vars, ToExpression[f$n]]];
table$list= My$Truth$Table[n$vars, ToExpression[f$n]];
table$1   = Transpose[Drop[table$list, 1]];
table$res = Take[table$1, -n$funcs];

table$string = Map[ToString[#]&, Flatten[table$list]];
logic$frules = MapThread[
               ("\""<>FromCharacterCode[#1+96]<>"\"->\""<>#2<>"\"")&,
                         {Range[1,n$funcs], logic$funcs}];
change$header= Map[
                   StringReplace[#,ToExpression[logic$frules]]&,
                   table$string];
new$table$list = Partition[change$header, n$vars+n$funcs];

SetOptions[TableForm, TableAlignments->Center];
output$table = new$table$list
]


lgex$rightanswer[x___]:=Module[{text},
text = "Cell[TextData[{"<>
"\"Your answer is correct.\", \"\\n\","<>
"\"The truth tables of the two statement forms are:\", \"\\n\\n\","<>
"Cell[SetTheory`Logic$exs$02`Private`table$1$2, \"Text\"], \"\\n\" "<>
"}],"<>
"\"Text\", FontSize->14, FontWeight->\"Bold\","<>
"ShowCellBracket->False,CellFrame->True]"
]


lgex$wronganswer[x___]:=Module[{text},
text = "Cell[TextData[{"<>
"\"You are wrong.\", \"\\n\","<>
"\"The truth tables of the two statement forms are\", \"\\n\\n\","<>
"Cell[SetTheory`Logic$exs$02`Private`table$1$2, \"Text\"], \"\\n\" "<>
"}],"<>
"\"Text\",FontSize->14,FontWeight->\"Bold\",FontColor->RGBColor[1.,0.,0.],"<>
"ShowCellBracket->False,CellFrame->True]"
]


(* EPILOG *)

SetAttributes[ select$f$pairs,    ReadProtected]
SetAttributes[ clr,               ReadProtected]
SetAttributes[ generate$onetable, ReadProtected]
SetAttributes[ My$Truth$Table,    ReadProtected]
SetAttributes[ lgex$rightanswer,  ReadProtected]
SetAttributes[ lgex$wronganswer,  ReadProtected]

Protect[Evaluate[logic$protected$2]]

End[]  (*logic$exs$2$02`Private`*)

Protect[logic$2]

EndPackage[] (* logic$exs$2$02`*)


