
(* :Title: Mappings$exs *)

(* :Author: N. A. Nicorovici, School of Mathematical Sciences, 
            University of Technology, Sydney, NSW 2007, Australia. 
*)

(* :Summary:
Exercises with functions.
*)

(* :Context: SetTheory`Mappings$exs` *)

(* :Package Version: 1.0 *)

(* :Copyright: *)

(* :History:
Version 1.0 by N. A. Nicorovici, 1999. 
Adapted for MSP 22 Jun 2002.
*)

(* :Keywords:
	Relations, Functions
*)

(* :Source: None. *)

(* :Warning: *)

(* :Mathematica Version: 3.0 *)

(* :Requirements: None *)

(* :Limitations: None known. *)

(* :Discussion: *)

BeginPackage["SetTheory`Mappings$exs`"]

select$ex

Unprotect[select$ex]

Begin["`Private`"]

mpp$protected= Unprotect[select$tdc]
evaluation$check = False

select$tdc[x_]:=Module[{left$symbols,right$symbols,types$1,mask$1,
                          nl,nr,nt,nn},

left$symbols  = {"a","b","c","d","e","f","g"};
right$symbols = {"t","u","v","w","x","y","z"};
types$1       = {"a RELATION","a 1-1","an ONTO","a 1-1 and ONTO"};
mask$1        = {      1,        2,       3,            4       };

If[ x > 4, nt = Random[Integer, {2,4}], nt=x ];
nl = Random[Integer, {1,7}];
nr = Random[Integer, {1,7}];
If[ (nt==4)&&(nl != nr), nn=Max[nl,nr]; nl=nn; nr=nn ];
If[ (nt==3)&&(nl  < nr), nn=nl; nl=nr; nr=nn ];
If[ (nt==3)&&(nl == nr), If[nr <7, nl=nl+1];
                         If[nr==7, nr=nr-1] ];   
If[ (nt==2)&&(nl  > nr), nn=nl; nl=nr; nr=nn ];
If[ (nt==2)&&(nl == nr), If[nl <7, nr=nr+1];
                         If[nl==7, nl=nl-1] ];

f$domain   = Take[left$symbols,  nl];
f$codomain = Take[right$symbols, nr];
f$type     = types$1[[nt]];
f$mask     = mask$1[[nt]];

{f$domain, f$codomain, f$type}
]


select$ex[x_]:=Module[{domain,codomain,type},

{domain, codomain, type} = select$tdc[x];

f$text = "Let f:A->B be "<>type<>" function having the domain\n"<>
         "\t\tA = "<>ToString[domain]<>"\n"<>
         "and the codomain\n"<>
         "\t\tB = "<>ToString[codomain]<>".";

SetTheory`Mappings$exs`Private`f$text
]


(* EPILOG *)

SetAttributes[select$tdc, ReadProtected]

Protect[Evaluate[mpp$protected]]

End[]  (*Mappings$exs`Private`*)

SetAttributes[select$ex,  ReadProtected]

Protect[select$ex]

EndPackage[] (* Mappings$exs`*)


