(* :Title: Master Declarations File for SetTheory *)

(* :Summary:
 	 This file contains declarations of all the major symbols
 	 contained in files in this directory.  When loaded, it sets
 	 up the symbols with attribute Stub, so the correct package
 	 will be loaded when the symbol is called. *)

(* :Author: This file was created by an automated system written in
 	 Mathematica by Roman E. Maeder *)

(* :History: File created on 12 March 2001 *)

(* :Sources:
 	 Roman E. Maeder. Programming in Mathematica,
 	 3rd ed. Addison-Wesley, 1996 *)


BeginPackage["SetTheory`Master`"]

EndPackage[]

DeclarePackage["SetTheory`settheory1$exs`", {"MSPSetTheory1", "settheory1$exs$3"}]

DeclarePackage["SetTheory`Operations$1`", {"SetOps$1", "MSP$SetOps"}]

DeclarePackage["SetTheory`Set$Complement`", {"sc$1", "MSP$SetCo"}]

DeclarePackage["SetTheory`Operations$N`", {"n$ops", "MSP$Ops", "Not$op"}]

DeclarePackage["SetTheory`VennDiagram`", 
  {"Lc", "MatchExpressions", "RandomVennDiagram", 
   "ShowParts", "VennDiagram", "MSPSyntaxCheck", "StringSyntax"}]

DeclarePackage["SetTheory`ReduceLogical`",
  {"U", "S", "H", "convert2standard", "convert2function", "ReduceExpression"}]

DeclarePackage["SetTheory`PartsList`",
  {"StringParts", "V", "X", "W", "Functional2Polish", "Polish2Functional",
   "Functional2Principia", "Principia2Functional", "Principia2Polish", 
   "Polish2Principia"}]

DeclarePackage["SetTheory`Cartesian$Products`", 
  {"cp$1", "cp$exs", "syntax$check", "MSP$Syntax$Check"}]

DeclarePackage["SetTheory`Power$Sets`",
  {"ps$1", "MSP$ps$1", "psparts$1", "MSP$psparts$1"}]

DeclarePackage["SetTheory`Relations`", 
  {"MSPRelation", "MSPSymmRel", "SymmRel", "Relation", "MSP$Relation$sc1"}]

DeclarePackage["SetTheory`functions1$exs`", 
  {"functions1$exs$3", "functions1$exs$f", "functions2$exs$t",
   "functions2$exs$c", "MSP$functions1$exs$3", "MSP$Functions$sc1", "MSP$functions1$exs$f",
   "MSP$functions2$exs$t", "MSP$functions2$exs$c"}]

DeclarePackage["SetTheory`CompositionOfFunctions$exs`",
  {"MSP$cof$sc", "MSP$cof$cp", "SyntaxError", "CoF$msg"}]

DeclarePackage["SetTheory`Mappings`", {"Mappings", "Mappings$Error", "MSP$pairstring"}]

DeclarePackage["SetTheory`Mappings$exs`", {"select$ex"}]

DeclarePackage["SetTheory`InverseMappings$exs`", 
  {"InverseMappings$Error", "InverseMappings$msg", "MSP$cp$1"}]

DeclarePackage["SetTheory`Logic`",
  {"T", "F", "A", "C", "E", "K", "M",
   "LogicAliases", "LogicGlossary", "PrincipiaGlossary",
   "FunctionalToPolish", "PolishToFunctional", "FunctionalToPrincipia",
   "PrincipiaToFunctional", "PrincipiaToPolish", "PolishToPrincipia",
   "TruthTable", "TautologyQ", "ContradictionQ", "ContingentQ"}]

DeclarePackage["SetTheory`Logic$exs$01`", {"logic$1", "Logic$msg"}]

DeclarePackage["SetTheory`Logic$exs$02`", {"logic$2"}]

(* End of Master Package *)

Null
