
(* :Title: functions1$exs *)

(* :Author: N. A. Nicorovici, School of Mathematical Sciences, 
            University of Technology, Sydney, NSW 2007, Australia. 
*)

(* :Summary:
This package contains functions to check the answers to the
exercises in the Chapter: Functions and relations.
*)

(* :Context: SetTheory`functions1$exs` *)

(* :Package Version: 1.0 *)

(* :Copyright: *)

(* :History:
Version 1.0 by N. A. Nicorovici, 1999. 
*)

(* :Keywords:
	SetTheory, Sets, Elements
*)

(* :Source: None. *)

(* :Warning: *)

(* :Mathematica Version: 3.0 *)

(* :Requirements: None *)

(* :Limitations: None known. *)

(* :Discussion: *)
                  
BeginPackage["SetTheory`functions1$exs`"]

MSP$functions1$exs$3::usage = 
"MSP$functions1$exs$3[A,B] verifies if the sets A and B are different, identical,
or partially identical."

MSP$functions1$exs$f::usage = 
"MSP$functions1$exs$f[A,B] verifies if the sets A and B are different, identical,
or partially identical, for fractional numbers."

MSP$functions2$exs$t::usage = 
"MSP$functions2$exs$t[A,R,T] verifies if the answer T is correct for exercises
with transitive sets."

MSP$functions2$exs$c::usage = 
"MSP$functions2$exs$c[A,R,C], where A is a set and R an equivalence relation
on A, verifies if the answer C (equivalence classes) is correct."

functions1$exs$3

MSP$Functions$sc1

functions1$exs$f

functions2$exs$t

functions2$exs$c


fnexs3$protected = Unprotect[functions1$exs$3, functions1$exs$f,
                             functions2$exs$t, functions2$exs$c,
                             MSP$Functions$sc1,
                             MSP$functions1$exs$3, MSP$functions1$exs$f,
                             MSP$functions2$exs$t, MSP$functions2$exs$c]

Begin["`Private`"]

f3$private$protected = Unprotect[ elclass, clsses, pairstring1]

(* Colors *)

Blue   = RGBColor[0.,0.,1.] ;
Yellow = RGBColor[1.,1.,0.] ;
Red    = RGBColor[1.,0.,0.];
Green  = RGBColor[0., 1.0, 0.]

cellbkg = RGBColor[1.,0.380001,0.009995] (* CadmiumOrange *) 

Red = RGBColor[1.0, 0., 0.];

ftype = RGBColor[0.529405,0.807794,0.980407];


(* Parameter and Function Definitions *)

nolf = {"\\012"->"", " "->""} ;


pairstring1[s0_] := Module[{s1,sx,nlb,nrb,ncommas},

	s1 = StringReplace[ToString[s0], {"\\012"->"", " "->"", "+"->"", "("->"{", ")"->"}"}];

	sx = Characters[s1];
	If[Length[sx] == 2, 
	Throw[False, Syntax$msg["You have to enter your answer before checking it."]];
	];


	nlb = Length[Select[sx, (#=="{")&]];
	nrb = Length[Select[sx, (#=="}")&]];
	If[nlb != nrb, 
	Throw[False, Syntax$msg["Unbalanced parentheses."]];
	];

	ncommas = Length[Select[sx, (#==",")&]];
	If[(nlb+nrb-3) != ncommas, 
	Throw[False, Syntax$msg["Too many commas or missing comma(s)."]];
	];

{True, s1}
];


MSP$Functions$sc1[s0_] := Module[{tmp, res},
  tmp = Catch[ pairstring1[s0], _Syntax$msg, List];
  res = tmp
];


elclass[el_,set_,rel_]:=Select[set, MemberQ[rel, {el,#}]&]

classes[set_,rel_]:=Map[elclass[#,set,rel]&,set]


(* MAIN FUNCTIONS *)

answer$count = 0;
current$question = {};
previous$question = {};

functions1$exs$3[Q_,R_] := Module[
                           {checkanswer,maxlength,R$length,ck$length},

  maxlength   = Length[Q];
  right$answer= ToString[Q];
  R$length    = Length[R];
  checkanswer = Intersection[Q, R];
  ck$length   = Length[checkanswer];
  stanswer    = ToString[checkanswer];
  current$question = Q;
If[ current$question =!= previous$question,
    previous$question = current$question;
    answer$count = 0 ];
  answer$count++;

If[ answer$count<3,
If[ ck$length==0,
    Throw[False, Functions["Your answer is wrong."]]];

If[ (ck$length==maxlength)&&(R$length==maxlength),
    previous$question = current$question;
    answer$count = 4;
    Throw[True, Functions["Your answer is correct."]]];

If[ 0<ck$length<=maxlength,
    Throw[True, Functions["Only the part:\n"<>
                SetTheory`functions1$exs`Private`stanswer<>
                "\nfrom your answer is correct."]]]
];

If[ answer$count==3,
    previous$question = current$question;
    answer$count = 4;
If[ ck$length==0,
    Throw[False, Functions["Your answer is wrong."<>
                 "\n\nThe correct answer is:\n"<>
                 SetTheory`functions1$exs`Private`right$answer]]];

If[ (ck$length==maxlength)&&(R$length==maxlength),
    Throw[True, Functions["Your answer is correct."]]];

If[ 0<ck$length<=maxlength,
    Throw[True, Functions["Only the part:\n"<>
                 SetTheory`functions1$exs`Private`stanswer<>
                "\nfrom your answer is correct."<>
                 "\n\nThe correct answer is:\n"<>
                 SetTheory`functions1$exs`Private`right$answer]]]
];

If[ answer$count>3,
    Throw[False, Functions["Try another exercise."]]];
]


MSP$functions1$exs$3[Q_,R_] := Module[{tmp,res},
  tmp = Catch[ functions1$exs$3[Q, R], _Functions, List];
  res = tmp
]


functions1$exs$f[Q_,R_,sw_] := Module[
                           {maxlength,R$length,ck$length},

  maxlength    = Length[Q];
  right$answer = ToString[Q];
  R$length     = Length[R];
  check$answer = Intersection[Q, R];
  ck$length    = Length[check$answer];
  stanswer     = ToString[check$answer];
  current$question = {sw};

If[ current$question =!= previous$question,
    previous$question = current$question;
    answer$count = 0 ];

  answer$count++;

If[ answer$count<3,
If[ ck$length==0,
    Throw[False, Functions["Your answer is wrong."]]];

If[ (ck$length==maxlength)&&(R$length==maxlength),
    previous$question = current$question;
    answer$count = 4;
    Throw[True, Functions["Your answer is correct."]]];

If[ 0<ck$length<=maxlength,
    Throw[True, Functions["Only the part:\n"<>
                SetTheory`functions1$exs`Private`stanswer<>
                "\nfrom your answer is correct."]]]
];

If[ answer$count==3,
    previous$question = current$question;
    answer$count = 4;
If[ ck$length==0,
    Throw[False, Functions["Your answer is wrong."<>
                 "\n\nThe correct answer is:\n"<>
                 SetTheory`functions1$exs`Private`right$answer]]];

If[ (ck$length==maxlength)&&(R$length==maxlength),
    Throw[True, Functions["Your answer is correct."]]];

If[ 0<ck$length<=maxlength,
    Throw[True, Functions["Only the part:\n"<>
                 SetTheory`functions1$exs`Private`stanswer<>
                "\nfrom your answer is correct."<>
                 "\n\nThe correct answer is:\n"<>
                 SetTheory`functions1$exs`Private`right$answer]]]
];

If[ answer$count>3,
    Throw[False, Functions["Try another exercise."]]];    
]


MSP$functions1$exs$f[Q_,R_,sw_] := Module[{tmp,res},
  tmp = Catch[ functions1$exs$f[Q, R, sw], _Functions, List];
  res = tmp
]


functions2$exs$t[A$set_,R$rel_,T$ans_,sw_] := Module[
  {checkanswer,maxlength,R$length,ck$length,rflag,sflag,tflag,rr,ss,tt},

(* Answer *)
  R = T$ans;

(* Set type: *)
  rflag = False; sflag = False; tflag = False;
(* Reflexive set *)
  rr = Map[{#,#}&, A$set];
  If[Length[Intersection[rr, R$rel]]==Length[rr], rflag=True];
(* Symmetric set *)
  ss = Complement[Flatten[Outer[{#1,#2}&,A$set,A$set],1], rr];
  If[Length[Intersection[ss, R$rel]]==Length[ss], sflag=True];
(* Total set *)
  tt = Flatten[Outer[{#1,#2}&,A$set,A$set],1];

(* NotNotTransitive --> Transitive *)
  If[(rflag==False)&&(sflag==False), Q=R$rel, Q=tt];

  maxlength   = Length[Q];
  right$answer= ToString[Q];
  R$length    = Length[R];
  checkanswer = Intersection[Q, R];
  ck$length   = Length[checkanswer];
  stanswer    = ToString[checkanswer];
  current$question = {sw};
If[ current$question =!= previous$question,
    previous$question = current$question;
    answer$count = 0 ];
  answer$count++;

If[ answer$count<3,
If[ ck$length==0,
    Throw[False, Functions["Your answer is wrong."]]];

If[ (ck$length==maxlength)&&(R$length==maxlength),
    previous$question = current$question;
    answer$count = 4;
    Throw[True, Functions["Your answer is correct."]]];

If[ 0<ck$length<=maxlength,
    Throw[True, Functions["Only the part:\n"<>
                SetTheory`functions1$exs`Private`stanswer<>
                "\nfrom your answer is correct."]]]
];

If[ answer$count==3,
    previous$question = current$question;
    answer$count = 4;
If[ ck$length==0,
    Throw[False, Functions["Your answer is wrong."<>
                 "\n\nThe correct answer is:\n"<>
                 SetTheory`functions1$exs`Private`right$answer]]];

If[ (ck$length==maxlength)&&(R$length==maxlength),
    Throw[True, Functions["Your answer is correct."]]];

If[ 0<ck$length<=maxlength,
    Throw[True, Functions["Only the part:\n"<>
                 SetTheory`functions1$exs`Private`stanswer<>
                "\nfrom your answer is correct."<>
                 "\n\nThe correct answer is:\n"<>
                 SetTheory`functions1$exs`Private`right$answer]]]
];

If[ answer$count>3,
    Throw[False, Functions["Try another exercise."]]];  
]


MSP$functions2$exs$t[A$set_,R$rel_,T$ans_,sw_] := Module[{tmp,res},
  tmp = Catch[ functions2$exs$t[A$set, R$rel, T$ans, sw], _Functions, List];
  res = tmp
]


functions2$exs$c[A$set_,R$rel_,C$ans_,sw_] := Module[
  {checkanswer,maxlength,R$length,ck$length},

(* Answer *)
  R = C$ans;

(* Find classes *)
  Q = classes[A$set, R$rel];

  maxlength   = Length[Q];
  right$answer= ToString[Q];
  R$length    = Length[R];
  checkanswer = Intersection[Q, R];
  ck$length   = Length[checkanswer];
  stanswer    = ToString[checkanswer];
  current$question = {sw};
If[ current$question =!= previous$question,
    previous$question = current$question;
    answer$count = 0 ];
  answer$count++;

If[ answer$count<3,
If[ ck$length==0,
    Throw[False, Functions["Your answer is wrong."]]];

If[ (ck$length==maxlength)&&(R$length==maxlength),
    previous$question = current$question;
    answer$count = 4;
    Throw[True, Functions["Your answer is correct."]]];

If[ 0<ck$length<=maxlength,
    Throw[True, Functions["Only the part:\n"<>
                SetTheory`functions1$exs`Private`stanswer<>
                "\nfrom your answer is correct."]]]
];

If[ answer$count==3,
    previous$question = current$question;
    answer$count = 4;
If[ ck$length==0,
    Throw[False, Functions["Your answer is wrong."<>
                 "\n\nThe correct answer is:\n"<>
                 SetTheory`functions1$exs`Private`right$answer]]];

If[ (ck$length==maxlength)&&(R$length==maxlength),
    Throw[True, Functions["Your answer is correct."]]];

If[ 0<ck$length<=maxlength,
    Throw[True, Functions["Only the part:\n"<>
                 SetTheory`functions1$exs`Private`stanswer<>
                "\nfrom your answer is correct."<>
                 "\n\nThe correct answer is:\n"<>
                 SetTheory`functions1$exs`Private`right$answer]]]
];

If[ answer$count>3,
    Throw[False, Functions["Try another exercise."]]];  
]


MSP$functions2$exs$c[A$set_,R$rel_,C$ans_,sw_] := Module[{tmp,res},
  tmp = Catch[ functions2$exs$c[A$set, R$rel, C$ans, sw], _Functions, List];
  res = tmp
]



(* Epilog *)

SetAttributes[ elclass,     ReadProtected]
SetAttributes[ classes,     ReadProtected]
SetAttributes[ pairstring1, ReadProtected]

Protect[Evaluate[f3$private$protected]]

End[]  (*functions1$exs`Private`*)

SetAttributes[ functions1$exs$3,     ReadProtected]
SetAttributes[ functions1$exs$f,     ReadProtected]
SetAttributes[ functions2$exs$t,     ReadProtected]
SetAttributes[ functions2$exs$c,     ReadProtected]
SetAttributes[ MSP$functions1$exs$3, ReadProtected]
SetAttributes[ MSP$Functions$sc1,    ReadProtected]
SetAttributes[ MSP$functions1$exs$f, ReadProtected]
SetAttributes[ MSP$functions2$exs$t, ReadProtected]
SetAttributes[ MSP$functions2$exs$c, ReadProtected]


Protect[Evaluate[fnexs3$protected]]

EndPackage[] (* functions1$exs`*)

