
(* :Title: settheory1$exs *)

(* :Author: N. A. Nicorovici, School of Mathematical Sciences, 
            University of Technology, Sydney, NSW 2007, Australia. 
*)

(* :Summary:
This package contains functions to check the answers to the
exercises in the Chapter: Sets and elements of sets.
*)

(* :Context: SetTheory`settheory1$exs` *)

(* :Package Version: 1.0 *)

(* :Copyright: *)

(* :History:
Version 1.0 by N. A. Nicorovici, 1999. Adapted for MSP, 2002.
*)

(* :Keywords:
	SetTheory, Sets, Elements
*)

(* :Source: None. *)

(* :Warning: *)

(* :Mathematica Version: 3.0 or higher *)

(* :Requirements: None *)

(* :Limitations: None known. *)

(* :Discussion: *)
                  
BeginPackage["SetTheory`settheory1$exs`"]

MSPSetTheory1::usage =
"MSPSetTheory1[A,B,n] picks up the messages from  settheory1$exs$3[A,B,n]  and
generate a form suitable for MSP."

settheory1$exs$3::usage = 
"settheory1$exs$3[A,B,n] verifies if the sets A and B are different, identical,
or partially identical, for the exercise n."

AnswerCheck


stexs3$protected = Unprotect[MSPSetTheory1, settheory1$exs$3]

Begin["`Private`"]

(* Colors *)

Blue   = RGBColor[0.,0.,1.] ;
Yellow = RGBColor[1.,1.,0.] ;
Red    = RGBColor[1.,0.,0.];
Green  = RGBColor[0., 1.0, 0.]

cellbkg = RGBColor[1.,0.380001,0.009995] (* CadmiumOrange *) 

Red = RGBColor[1.0, 0., 0.];

ftype = RGBColor[0.529405,0.807794,0.980407];

(* Parameter and Function Definitions *)

nolf = {"\\012"->"", " "->""} ;


(* MAIN FUNCTIONS *)

settheory1$count = 0
settheory1$flag1 = 0
settheory1$flag2 = 0


MSPSetTheory1[Q_, R_, flag_Integer] := Module[{tmp,res},
  tmp = Catch[ settheory1$exs$3[Q, R, flag], _AnswerCheck, List];
  res = tmp
]


settheory1$exs$3[Q_, R_, flag_Integer] := Module[
                           {checkanswer,maxlength,R$length,ck$length},

  maxlength   = Length[Q];
  right$answer= ToString[Q];
  R$length    = Length[R];
  checkanswer = Intersection[Q, R];
  ck$length   = Length[checkanswer];
  stanswer    = ToString[checkanswer];
  settheory1$flag1 = flag;

If[ settheory1$flag1 != settheory1$flag2,
    settheory1$flag2  = settheory1$flag1;
    settheory1$count = 0 ];
  settheory1$count++;


If[ settheory1$count<3,
If[ ck$length==0,
    Throw[False, AnswerCheck[ " Your answer is wrong."]];
    Return[False]];

If[ (ck$length==maxlength)&&(R$length==maxlength),
    settheory1$flag2 = settheory1$flag1;
    settheory1$count = 4;
    Throw[True, AnswerCheck[ " Your answer is correct."]];
    Return[True]];

If[ 0<ck$length<=maxlength,
    Throw[False, 
          AnswerCheck[ "Only the part\n\t\t\t"<>
            SetTheory`settheory1$exs`Private`stanswer<>"\n\t\t  from your answer is correct."]];
    Return[False]]
];


If[ settheory1$count==3,
    settheory1$flag2 = settheory1$flag1;
    settheory1$count = 4;
If[ ck$length==0,
    Throw[False, 
          AnswerCheck[ "Your answer is wrong. The correct answer is\n\t\t\t"<>
            SetTheory`settheory1$exs`Private`right$answer<>"."]];
    Return[False]];

If[ (ck$length==maxlength)&&(R$length==maxlength),
    Throw[True, AnswerCheck[ " Your answer is correct."]];
    Return[True]];

If[ 0<ck$length<=maxlength,
    Throw[False, 
          AnswerCheck[ "Only the part\n\t\t\t"<>
	    SetTheory`settheory1$exs`Private`stanswer<>
            "\n\t\t  from your answer is correct. The correct answer is\n\t\t\t"<>
            SetTheory`settheory1$exs`Private`right$answer<>"."]];
    Return[False]]
];


If[ settheory1$count>3,
    Throw[False, AnswerCheck[ " Try another exercise."]];
    Return[False]]
]


(* Epilog *)

End[]  (*settheory1$exs`Private`*)

SetAttributes[ MSPSetTheory1,    ReadProtected]
SetAttributes[ settheory1$exs$3, ReadProtected]

Protect[Evaluate[stexs3$protected]]

EndPackage[] (* settheory1$exs`*)


